# VirtualHost設定用リソース定義

define pbp_apache_rh7::config_virtualhost (
  String $vhostname,
  Array  $vhost_info,
) {

  # VirtualHost有効/無効の切り替え
  case $vhost_info[1] {
    true:    { $vhost_status = file   }
    false:   { $vhost_status = absent }
    default: { $vhost_status = absent } # ture/false以外の場合は無効
  }

  # VirtualHost設定
  file { "/etc/httpd/conf.d/virtualhost_${vhostname}.conf":
    ensure  => $vhost_status,
    content => epp('pbp_apache_rh7/vhost.conf.epp',
    {
      vhost_name => $vhostname,
      vhost_fqdn => $vhost_info[0],
    } ),
    notify  => Service['httpd'],
  }

  # VirtualHost用コンテンツ作成
  file { "/var/www/html/${vhostname}":
    ensure  => directory,
  }
  file { "/var/www/html/${vhostname}/index.html":
    ensure  => file,
    content => "<html><body>this is ${vhostname}.</body></html>",
    require => File["/var/www/html/${vhostname}"],
  }
}
