#!/usr/bin/env python
# -*- coding: utf-8 -*-
###################################################################################################
# para_yaml.py 
# 利用方法:
#  python para_yaml.py <処理対象ファイル名> <Puppetモジュール名> 
###################################################################################################

##ライブラリ読み込み
import xlrd            #excelファイル読み込み用ライブラリ
import sys
import time
import re
import unicodedata
import glob
import types

##コマンドライン引数読み込み
args = sys.argv
excel = args[1]
mod_name = args[2] 


##設定ファイル内設定値取得
para_row_s = 5 
para_col_s = 2
para_col_e = 8
var_col = 9
def_col = 10
hosts_col_s = 11
flag_row = 4
hostname_row = 3 
on_flag = unicode("■",encoding='utf-8')
def_symbol = unicode("○",encoding='utf-8')

##処理対象Excelブック、シート読み込み
book = xlrd.open_workbook(excel)


##グローバル変数(リスト)初期化
host_names = []
host_num = []
var_names = []
var_num = []
number = 0


##シート内yaml出力対象ホスト名取得機能
def sheet_check():
    global hosts_col_s
    global host_names
    global host_num
    global flag_row
    col = hosts_col_s

    for col,flag in enumerate(sheet_1.row_values(flag_row)):
        #yamlフラグ行にフラグが立っている列の場合、ホスト名と列番号(yaml生成処理が必要な列番号)を取得
        if flag == on_flag:
            host_names.append(sheet_1.cell(hostname_row, col).value)
            host_num.append(col)

##全変数名取得機能
def paraname_get():
    global para_row_s
    global para_col_s
    global para_col_e
    global var_col
    global var_names
    global var_num
    row = para_row_s
    part_names = []
    var_name = ""
    depth = ""
    last_name = ""

    for row,num in enumerate(sheet_1.col_values(1)):
        #No列の数値有無で処理対象行を判定
        if num :
            for col in xrange(para_col_s,para_col_e+1):
                if sheet_1.cell(row,col).value:
                    #階層位置情報よりも浅い位置の場合、変数名の更新が発生するためその位置以降の変数名部品をクリア
                    if depth > col:
                        del part_names[col-2:para_col_e-2]
                    #処理階層が最下層の場合、最終的な変数名の作成処理
                    if col == para_col_e:
                        var_name = ""
                        for part_name in part_names:
                            if part_name :
                                var_name += part_name + '_'
                        #変数名列に値が存在する場合はそちらを、しない場合は最下層の値を利用して最終的な変数名を生成
                        if sheet_1.cell(row,var_col).value:
                            last_name = re.sub(re.compile("[!-/:-@[-`{-~]"),"_",str(var_name + str(sheet_1.cell(row,var_col).value)).lower())
                            var_names.append(last_name)
                            var_num.append(int(row))
                        else:
                            flag = ''
                            for ch in sheet_1.cell(row,col).value:
                                if "CJK UNIFIED" in unicodedata.name(ch) or "HIRAGANA" in unicodedata.name(ch) or "KATAKANA" in unicodedata.name(ch):
                                    flag = 'True'
                            #値が日本語でない場合のみセルの値を変数名の部品として格納
                            if not flag :
                                last_name = re.sub(re.compile("[!-/:-@[-`{-~]"),"_",str(var_name + str(sheet_1.cell(row,col).value)).lower())
                                #最終的な変数名と変数名が生成された行番号(パラメータ取得が必要な行番号)をそれぞれ格納
                                var_names.append(last_name)
                                var_num.append(int(row))
                    #処理階層が最下層以外の場合、変数名の部品作成処理
                    else:
                        #変数名列に値が存在する場合はそちらを、ない場合は最下層の値を利用して変数名の部品を生成
                        if sheet_1.cell(row,var_col).value:
                            part_names.insert(col-2,sheet_1.cell(row,var_col).value)
                        else:
                            flag = ''
                            for ch in sheet_1.cell(row,col).value:
                                if "CJK UNIFIED" in unicodedata.name(ch) or "HIRAGANA" in unicodedata.name(ch) or "KATAKANA" in unicodedata.name(ch):
                                    flag = 'True'
                            #値が日本語でない場合のみセルの値を変数名の部品として格納
                            if not flag :
                                part_names.insert(col-2,sheet_1.cell(row,col).value)
                            else:
                                part_names.insert(col-2,'')
                        break
                    #処理中の階層位置情報更新
                    depth = col

##yaml生成機能(引数:(列番号、ホスト名)形式のリスト)
def yaml_make(hostname):
    global var_names
    global var_num
    global def_col 
    global mod_name
    value = ''

    yaml = open('output/'+hostname[1]+'.yaml', 'a')
    for row,var_name in enumerate(var_names):
        flag = ''
        if sheet_1.cell(var_num[row],hostname[0]).value not in ['-','']:
            if sheet_1.cell(var_num[row],hostname[0]).value in [def_symbol]:
                value = sheet_1.cell(var_num[row],def_col).value
            else:
                value = sheet_1.cell(var_num[row],hostname[0]).value
            for ch in unicode(value) :
                if "CJK UNIFIED" in unicodedata.name(ch) or "HIRAGANA" in unicodedata.name(ch) or "KATAKANA" in unicodedata.name(ch):
                    flag = 'True'
            if not flag:
                value = re.sub(r'\\n',r'\\\\n',str(value))
                value = re.sub(r'"',r'\"',value)
                if re.match(r'^[0-9]+\.0$',value):
                    value = re.sub(r'\.0','',value)
                yaml.write(mod_name+'::'+var_name+': '+'"'+value+'"'+"\n")
            else:
                yaml.write(mod_name+'::'+var_name+': '+'"'+value.encode('utf_8') +'"'+"\n")
    yaml.write(mod_name+'::_flag: '+'"on"'+"\n")
    yaml.close


##メイン処理
if __name__ == '__main__':

    for sheet_1 in book.sheets():
        sheet_check()
        if host_names:
            paraname_get()
            for host in zip(host_num,host_names):
                yaml_make(host)
            host_names = []
            host_num = []
            var_names = []
            var_num = []
